"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const object_1 = require("./helpers/object");
function TableBody({ tableHeaders, labels, data, classes, components: { TableBody, TableRow, TableCell }, onRowClick }) {
    const body = [];
    const dataLength = data.length;
    if (dataLength !== 0) {
        for (let i = 0; i < dataLength; i += 1) {
            body.push(react_1.default.createElement(BodyRow, { key: `row-${i}`, classes: classes, components: {
                    TableRow,
                    TableCell
                }, tableHeaders: tableHeaders, data: data, onClick: onRowClick, rowIdx: i }));
        }
    }
    else {
        body.push(react_1.default.createElement(TableRow, { key: `row-zero-length`, className: "tbody-tr" },
            react_1.default.createElement(TableCell, { className: "tbody-td", colSpan: tableHeaders.length }, (labels === null || labels === void 0 ? void 0 : labels.noResults) || 'No results to be shown.')));
    }
    return (react_1.default.createElement(TableBody, { className: (0, object_1.makeClasses)('tbody', classes === null || classes === void 0 ? void 0 : classes.tbody) }, body));
}
exports.default = TableBody;
function BodyRow({ tableHeaders, data, rowIdx, classes, components, onClick }) {
    const row = [];
    for (let i = 0; i < tableHeaders.length; i += 1) {
        const { cell, cellProps = {} } = tableHeaders[i];
        let value = '';
        if (cell === undefined) {
            value = data[rowIdx][tableHeaders[i].prop];
        }
        else {
            value = cell(data[rowIdx]);
        }
        row.push(react_1.default.createElement(components.TableCell, { key: `col-${rowIdx}${i}`, className: (0, object_1.makeClasses)('tbody-td', classes === null || classes === void 0 ? void 0 : classes.tbodyCol, typeof cellProps.className === 'function'
                ? cellProps.className(data[rowIdx])
                : cellProps.className), style: typeof cellProps.style === 'function'
                ? cellProps.style(data[rowIdx])
                : cellProps.style }, value));
    }
    function onRowClick() {
        if (typeof onClick === 'function') {
            onClick(data[rowIdx]);
        }
    }
    return (react_1.default.createElement(components.TableRow, { className: (0, object_1.makeClasses)('tbody-tr', classes === null || classes === void 0 ? void 0 : classes.tbodyRow), onClick: onRowClick }, row));
}
